Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34921)
@@ -2843,8 +7309,8 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Single Area',
-            0x20 => 'Dynamic Area',
-            0x40 => 'Auto-area',
-            0x60 => '3D-tracking (11 points)',
+            0 => 'Single Area',
+            1 => 'Dynamic Area',
+            2 => 'Auto-area',
+            3 => '3D-tracking (11 points)',
         },
     },
@@ -2852,8 +7318,5 @@
         Name => 'AFAssist',
         Mask => 0x01,
-        PrintConv => {
-            0 => 'On',
-            1 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     2.1 => { # CSd1
@@ -2861,7 +7324,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'Low',
-            0x80 => 'High',
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
         },
     },
@@ -2869,16 +7332,10 @@
         Name => 'GridDisplay',
         Mask => 0x02,
-        PrintConv => {
-            0x00 => 'On',
-            0x02 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     2.3 => { # CSd3
         Name => 'ISODisplay',
         Mask => 0x08,
-        PrintConv => {
-            0x08 => 'Off',
-            0x00 => 'On',
-        },
+        PrintConv => \%onOff,
     },
     2.4 => { # CSf4
@@ -2886,6 +7343,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Release Locked',
-            0x20 => 'Enable Release',
+            0 => 'Release Locked',
+            1 => 'Enable Release',
         },
     },
@@ -2893,18 +7350,15 @@
         Name => 'FileNumberSequence',
         Mask => 0x08,
-        PrintConv => { 0x00 => 'On', 0x08 => 'Off' },
+        PrintConv => \%onOff,
     },
     4.1 => { # CSa4
         Name => 'RangeFinder',
         Mask => 0x10,
-        PrintConv => { 0x00 => 'Off', 0x10 => 'On' },
+        PrintConv => \%offOn,
     },
     4.2 => { # CSd6
         Name => 'DateImprint',
         Mask => 0x08,
-        PrintConv => {
-            0x00 => 'Off',
-            0x08 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     4.3 => { # CSf5
@@ -2912,6 +7366,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => '+ 0 -',
-            0x80 => '- 0 +',
+            0 => '+ 0 -',
+            1 => '- 0 +',
         },
     },
@@ -2920,6 +7374,6 @@
         Mask => 0x40,
         PrintConv => {
-            0x00 => '1/3 EV',
-            0x40 => '1/2 EV',
+            0 => '1/3 EV',
+            1 => '1/2 EV',
         },
     },
@@ -2927,8 +7381,5 @@
         Name => 'ExposureDelayMode',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     11.1 => { # CSe2
@@ -2936,7 +7387,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Exposure',
-            0x40 => 'Active D-Lighting', #(NC)
-            0x80 => 'WB Bracketing',
+            0 => 'Exposure',
+            # (NOTE: the following are reversed in the D5100 -- is this correct?)
+            1 => 'Active D-Lighting', #(NC)
+            2 => 'WB Bracketing',
         },
     },
@@ -2945,12 +7397,12 @@
         Mask => 0x38,
         PrintConv => {
-            0x00 => 'Self-timer',
-            0x08 => 'Release Mode',
-            0x10 => 'Image Quality/Size', #(NC)
-            0x18 => 'ISO', #(NC)
-            0x20 => 'White Balance', #(NC)
-            0x28 => 'Active D-Lighting', #(NC)
-            0x30 => '+ NEF (RAW)',
-            0x38 => 'Auto Bracketing',
+            0 => 'Self-timer',
+            1 => 'Release Mode',
+            2 => 'Image Quality/Size', #(NC)
+            3 => 'ISO', #(NC)
+            4 => 'White Balance', #(NC)
+            5 => 'Active D-Lighting', #(NC)
+            6 => '+ NEF (RAW)',
+            7 => 'Auto Bracketing',
         },
     },
@@ -2959,9 +7411,9 @@
         Mask => 0x38,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x08 => 'AE Lock Only', #(NC)
-            0x10 => 'AF Lock Only', #(NC)
-            0x18 => 'AE Lock (hold)',
-            0x20 => 'AF-ON',
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only', #(NC)
+            2 => 'AF Lock Only', #(NC)
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
         },
     },
@@ -2969,10 +7421,10 @@
         Name => 'ShutterReleaseButtonAE-L',
         Mask => 0x02,
-        PrintConv => { 0x00 => 'Off', 0x02 => 'On' },
+        PrintConv => \%offOn,
     },
     16.2 => { # CSf3
         Name => 'CommandDialsReverseRotation',
         Mask => 0x80,
-        PrintConv => { 0x00 => 'No', 0x80 => 'Yes' },
+        PrintConv => \%noYes,
     },
     17.1 => { # CSc2-c
@@ -2980,9 +7432,9 @@
         Mask => 0x70,
         PrintConv => {
-            0x00 => '4 s',
-            0x10 => '8 s',
-            0x20 => '20 s',
-            0x30 => '1 min',
-            0x40 => '30 min',
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '30 min',
         },
     },
@@ -2991,8 +7443,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => '1 min',
-            0x01 => '5 min',
-            0x02 => '10 min',
-            0x03 => '15 min',
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
         },
     },
@@ -3001,8 +7453,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => '2 s',
-            0x40 => '5 s',
-            0x80 => '10 s',
-            0xc0 => '20 s',
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
         },
     },
@@ -3010,6 +7462,4 @@
         Name => 'SelfTimerShotCount',
         Mask => 0x1e,
-        ValueConv => '$val >> 1',
-        ValueConvInv => '$val << 1',
     },
     19.1 => { # CSc2-b
@@ -3017,9 +7467,9 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '4 s',
-            0x20 => '8 s',
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '10 min',
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '10 min',
         },
     },
@@ -3028,9 +7478,9 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '8 s',
-            0x20 => '12 s',
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '10 min',
+            0 => '8 s',
+            1 => '12 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '10 min',
         },
     },
@@ -3039,6 +7489,6 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'TTL',
-            0x40 => 'Manual',
+            0 => 'TTL',
+            1 => 'Manual',
         },
     },
@@ -3058,9 +7508,448 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Face Priority',
-            0x20 => 'Wide Area',
-            0x40 => 'Normal Area',
-            0x60 => 'Subject Tracking',
-        },
+            0 => 'Face Priority',
+            1 => 'Wide Area',
+            2 => 'Normal Area',
+            3 => 'Subject Tracking',
+        },
+    },
+);
+
+# D5100 custom settings (ref PH)
+%Image::ExifTool::NikonCustom::SettingsD5100 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Custom settings for the D5100.',
+    0.1 => { # CSa1
+        Name => 'AF-CPrioritySelection',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Release',
+            1 => 'Focus',
+        },
+    },
+    1.1 => { # CSa2
+        Name => 'AFAssist',
+        Mask => 0x01,
+        PrintConv => \%onOff,
+    },
+    3.1 => { # CSd1
+        Name => 'Beep',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
+        },
+    },
+    3.2 => { # CSf4
+        Name => 'NoMemoryCard',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Release Locked',
+            1 => 'Enable Release',
+        },
+    },
+    3.3 => { # CSd2
+        Name => 'ISODisplay',
+        Mask => 0x08,
+        PrintConv => \%onOff,
+    },
+    4.1 => { # CSd3
+        Name => 'FileNumberSequence',
+        Mask => 0x08,
+        PrintConv => \%onOff,
+    },
+    5.1 => { # CSa3
+        Name => 'RangeFinder',
+        Mask => 0x10,
+        PrintConv => \%offOn,
+    },
+    # (it looks like CSd5 DateImprint is not stored)
+    5.2 => { # CSf5
+        Name => 'ReverseIndicators',
+        Mask => 0x80,
+        PrintConv => {
+            0 => '+ 0 -',
+            1 => '- 0 +',
+        },
+    },
+    6.1 => { # CSb1
+        Name => 'EVStepSize',
+        Mask => 0x40,
+        PrintConv => {
+            0 => '1/3 EV',
+            1 => '1/2 EV',
+        },
+    },
+    10.1 => { # CSd4
+        Name => 'ExposureDelayMode',
+        Mask => 0x40,
+        PrintConv => \%offOn,
+    },
+    12.1 => { # CSe2
+        Name => 'AutoBracketSet',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Exposure',
+            # (NOTE: the following are reversed from the D5000 -- is D5000 correct?)
+            1 => 'WB Bracketing',
+            2 => 'Active D-Lighting',
+        },
+    },
+    13.1 => { # CSf1
+        Name => 'TimerFunctionButton',
+        Mask => 0x38,
+        PrintConv => {
+            0 => 'Self-timer',
+            1 => 'Release Mode',
+            2 => 'Image Quality/Size',
+            3 => 'ISO',
+            4 => 'White Balance',
+            5 => 'Active D-Lighting',
+            6 => '+ NEF (RAW)',
+            7 => 'Auto Bracketing',
+        },
+    },
+    16.1 => { # CSf2
+        Name => 'AELockButton',
+        Mask => 0x38,
+        PrintConv => {
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only',
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
+        },
+    },
+    17.1 => { # CSc1
+        Name => 'ShutterReleaseButtonAE-L',
+        Mask => 0x02,
+        PrintConv => \%offOn,
+    },
+    17.2 => { # CSf3
+        Name => 'CommandDialsReverseRotation',
+        Mask => 0x80,
+        PrintConv => \%noYes,
+    },
+    18.1 => { # CSc2-d
+        Name => 'MeteringTime',
+        Mask => 0x70,
+        PrintConv => {
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s', #(NC)
+            3 => '1 min',
+            4 => '30 min', #(NC)
+        },
+    },
+    18.2 => { # CSc4
+        Name => 'RemoteOnDuration',
+        Mask => 0x03,
+        PrintConv => {
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min', #(NC)
+            3 => '20 min', # (but picture in manual shows 15 min)
+        },
+    },
+    19.1 => { # CSc3-a
+        Name => 'SelfTimerTime',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
+        },
+    },
+    19.2 => { # CSc3-b
+        Name => 'SelfTimerShotCount',
+        Mask => 0x0f,
+    },
+    20.1 => { # CSc2-b
+        Name => 'ImageReviewTime',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '4 s',
+            1 => '8 s', #(NC)
+            2 => '20 s',
+            3 => '1 min', #(NC)
+            4 => '10 min', #(NC)
+        },
+    },
+    20.2 => { # CSc2-c
+        Name => 'LiveViewMonitorOffTime',
+        Mask => 0x1c,
+        PrintConv => {
+            0 => '3 min',
+            1 => '5 min', #(NC)
+            2 => '10 min',
+            3 => '15 min', #(NC)
+            4 => '20 min', #(NC)
+            5 => '30 min', #(NC)
+        },
+    },
+    21.1 => { # CSc2-a
+        Name => 'PlaybackMenusTime',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '8 s', #(NC)
+            1 => '12 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '10 min', #(NC)
+        },
+    },
+    23.1 => { # CSe1-a
+        Name => 'InternalFlash',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'TTL',
+            1 => 'Manual',
+        },
+    },
+    23.1 => { # CSe1-b
+        Name => 'ManualFlashOutput',
+        Mask => 0x1f,
+        ValueConv => '2 ** (-$val/3)',
+        ValueConvInv => '$val > 0 ? -3*log($val)/log(2) : 0',
+        PrintConv => q{
+            return 'Full' if $val > 0.99;
+            Image::ExifTool::Exif::PrintExposureTime($val);
+        },
+        PrintConvInv => '$val=~/F/i ? 1 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+);
+
+# D5200 custom settings (ref PH)
+%Image::ExifTool::NikonCustom::SettingsD5200 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Custom settings for the D5200.',
+    0.1 => { # CSa1
+        Name => 'AF-CPrioritySelection',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Release',
+            1 => 'Focus',
+        },
+    },
+    0.2 => { # CSa2
+        Name => 'NumberOfFocusPoints',
+        Mask => 0x10,
+        PrintConv => {
+            0 => '39 Points',
+            1 => '11 Points',
+        },
+    },
+    1.1 => { # CSa3
+        Name => 'AFAssist',
+        Mask => 0x01,
+        PrintConv => \%onOff,
+    },
+    3.1 => { # CSd1
+        Name => 'Beep',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
+        },
+    },
+    3.2 => { # CSf4
+        Name => 'NoMemoryCard',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Release Locked',
+            1 => 'Enable Release',
+        },
+    },
+    3.3 => { # CSd3
+        Name => 'ISODisplay',
+        Mask => 0x08,
+        PrintConv => \%onOff,
+    },
+    4.1 => { # CSd3
+        Name => 'FileNumberSequence',
+        Mask => 0x08,
+        PrintConv => \%onOff,
+    },
+    5.1 => { # CSa4
+        Name => 'RangeFinder',
+        Mask => 0x04,
+        PrintConv => \%offOn,
+    },
+    5.2 => { # CSf3-a
+        Name => 'ReverseExposureCompDial',
+        Mask => 0x10,
+        PrintConv => \%noYes,
+    },
+    5.3 => { # CSf3-b
+        Name => 'ReverseShutterSpeedAperture',
+        Mask => 0x08,
+        PrintConv => \%noYes,
+    },
+    5.4 => { # CSf5
+        Name => 'ReverseIndicators',
+        Mask => 0x80,
+        PrintConv => {
+            0 => '+ 0 -',
+            1 => '- 0 +',
+        },
+    },
+    6.1 => { # CSb1
+        Name => 'EVStepSize',
+        Mask => 0x40, # (bit 0x04 also changes)
+        PrintConv => {
+            0 => '1/3 EV',
+            1 => '1/2 EV',
+        },
+    },
+    10.1 => { # CSd5
+        Name => 'ExposureDelayMode',
+        Mask => 0x40,
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    12.1 => { # CSe2
+        Name => 'AutoBracketSet',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Exposure',
+            # (NOTE: the following are reversed from the D5000 -- is D5000 correct?)
+            1 => 'WB Bracketing',
+            2 => 'Active D-Lighting',
+        },
+    },
+    13.1 => { # CSf1
+        Name => 'FunctionButton',
+        Mask => 0x1f,
+        PrintConv => {
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            8 => 'AF-ON',
+            16 => '+ NEF (RAW)',
+            18 => 'Active D-Lighting',
+            25 => 'Live View',
+            26 => 'Image Quality',
+            27 => 'ISO',
+            28 => 'White Balance',
+            29 => 'HDR',
+            30 => 'Auto Bracketing',
+            31 => 'AF-area Mode',
+        },
+    },
+    16.1 => { # CSf2
+        Name => 'AELockButton',
+        Mask => 0x0f,
+        PrintConv => {
+            3 => 'AE/AF Lock',
+            4 => 'AE Lock Only',
+            6 => 'AE Lock (hold)',
+            7 => 'AF Lock Only',
+            8 => 'AF-ON',
+        },
+    },
+    17.1 => { # CSc1
+        Name => 'ShutterReleaseButtonAE-L',
+        Mask => 0x02,
+        PrintConv => \%offOn,
+    },
+    18.1 => { # CSc2-d
+        Name => 'StandbyTimer',
+        Mask => 0xe0,
+        PrintConv => {
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '30 min',
+        },
+    },
+    18.2 => { # CSc4
+        Name => 'RemoteOnDuration',
+        Mask => 0x03,
+        PrintConv => {
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
+        },
+    },
+    19.1 => { # CSc3-a
+        Name => 'SelfTimerTime',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
+        },
+    },
+    19.2 => { # CSc3-b
+        Name => 'SelfTimerShotCount',
+        Mask => 0x0f,
+    },
+    20.1 => { # CSc2-b
+        Name => 'ImageReviewTime',
+        Mask => 0xe0,
+        PrintConv => {
+            1 => '4 s',
+            2 => '8 s',
+            4 => '20 s',
+            5 => '1 min',
+            7 => '10 min',
+        },
+    },
+    20.2 => { # CSc2-c
+        Name => 'LiveViewMonitorOffTime',
+        Mask => 0x1c,
+        PrintConv => {
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
+            4 => '20 min',
+            5 => '30 min',
+        },
+    },
+    21.1 => { # CSc2-a
+        Name => 'PlaybackMenusTime',
+        Mask => 0xe0,
+        PrintConv => {
+            1 => '8 s',
+            4 => '20 s',
+            5 => '1 min',
+            6 => '5 min',
+            7 => '10 min',
+        },
+    },
+    23.1 => { # CSe1-a
+        Name => 'InternalFlash',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'TTL',
+            1 => 'Manual',
+        },
+    },
+    23.2 => { # CSe1-b
+        Name => 'ManualFlashOutput',
+        Mask => 0x1f,
+        ValueConv => '2 ** (-$val/3)',
+        ValueConvInv => '$val > 0 ? -3*log($val)/log(2) : 0',
+        PrintConv => q{
+            return 'Full' if $val > 0.99;
+            Image::ExifTool::Exif::PrintExposureTime($val);
+        },
+        PrintConvInv => '$val=~/F/i ? 1 : Image::ExifTool::Exif::ConvertFraction($val)',
     },
 );
@@ -3080,6 +7969,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => 'Release',
-            0x80 => 'Focus',
+            0 => 'Release',
+            1 => 'Focus',
         },
     },
@@ -3088,6 +7977,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Focus',
-            0x20 => 'Release',
+            0 => 'Focus',
+            1 => 'Release',
         },
     },
@@ -3096,6 +7985,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => '39 Points',
-            0x10 => '11 Points',
+            0 => '39 Points',
+            1 => '11 Points',
         },
     },
@@ -3104,33 +7993,33 @@
         Mask => 0x07,
         PrintConv => {
-            0x05 => '5 Long',
-            0x04 => '4',
-            0x03 => '3 Normal',
-            0x02 => '2',
-            0x01 => '1 Short',
-            0x00 => 'Off',
-        },
-    },
-    1.2 => { # CSa5
+            0 => 'Off',
+            1 => '1 Short',
+            2 => '2',
+            3 => '3 Normal',
+            4 => '4',
+            5 => '5 Long',
+        },
+    },
+    1.1 => { # CSa5
         Name => 'FocusPointWrap',
         Mask => 0x08,
         PrintConv => {
-            0x00 => 'No Wrap',
-            0x08 => 'Wrap',
-        },
-    },
-    1.3 => { # CSa4
+            0 => 'No Wrap',
+            1 => 'Wrap',
+        },
+    },
+    1.2 => { # CSa4
         Name => 'AFPointIllumination',
         Mask => 0x06,
         PrintConv => {
-            0x00 => 'Auto',
-            0x02 => 'On',
-            0x04 => 'Off',
-        },
-    },
-    1.4 => { # CSa7
+            0 => 'Auto',
+            1 => 'On',
+            2 => 'Off',
+        },
+    },
+    1.3 => { # CSa7
         Name => 'AFAssist',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'On', 0x01 => 'Off' },
+        PrintConv => \%onOff,
     },
     2.1 => { # CSd14
@@ -3138,6 +8027,6 @@
         Mask => 0x40,
         PrintConv => {
-            0x00 => 'MB-D11 First',
-            0x40 => 'Camera Battery First',
+            0 => 'MB-D11 First',
+            1 => 'Camera Battery First',
         },
     },
@@ -3146,11 +8035,11 @@
         Mask => 0x1c,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x04 => 'AE Lock Only',
-            0x08 => 'AF Lock Only',
-            0x0c => 'AE Lock (hold)',
-            0x10 => 'AF-ON',
-            0x14 => 'FV Lock',
-            0x18 => 'Same as FUNC Button',
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only',
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
+            5 => 'FV Lock',
+            6 => 'Same as FUNC Button',
         },
     },
@@ -3159,7 +8048,7 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'LR6 (AA alkaline)',
-            0x01 => 'Ni-MH (AA Ni-MH)',
-            0x02 => 'FR6 (AA lithium)',
+            0 => 'LR6 (AA alkaline)',
+            1 => 'Ni-MH (AA Ni-MH)',
+            2 => 'FR6 (AA lithium)',
         },
     },
@@ -3168,7 +8057,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'Low',
-            0x80 => 'High',
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
         },
     },
@@ -3177,6 +8066,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Release Locked',
-            0x20 => 'Enable Release',
+            0 => 'Release Locked',
+            1 => 'Enable Release',
         },
     },
@@ -3185,7 +8074,7 @@
         Mask => 0x0c,
         PrintConv => {
-            0x00 => 'Show ISO/Easy ISO',
-            0x04 => 'Show ISO Sensitivity',
-            0x0c => 'Show Frame Count',
+            0 => 'Show ISO/Easy ISO',
+            1 => 'Show ISO Sensitivity',
+            3 => 'Show Frame Count',
         },
     },
@@ -3193,10 +8082,10 @@
         Name => 'GridDisplay',
         Mask => 0x02,
-        PrintConv => { 0x00 => 'On', 0x02 => 'Off' },
+        PrintConv => \%onOff,
     },
     3.5 => { # CSd4
         Name => 'ViewfinderWarning',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'On', 0x01 => 'Off' },
+        PrintConv => \%onOff,
     },
     4.1 => { # CSd9
@@ -3204,7 +8093,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Auto',
-            0x80 => 'Manual (dark on light)',
-            0xc0 => 'Manual (light on dark)',
+            0 => 'Auto',
+            2 => 'Manual (dark on light)',
+            3 => 'Manual (light on dark)',
         },
     },
@@ -3212,15 +8101,15 @@
         Name => 'LCDIllumination',
         Mask => 0x20,
-        PrintConv => { 0x00 => 'Off', 0x20 => 'On' },
+        PrintConv => \%offOn,
     },
     4.3 => { # CSd8
         Name => 'FileNumberSequence',
         Mask => 0x08,
-        PrintConv => { 0x00 => 'On', 0x08 => 'Off' },
+        PrintConv => \%onOff,
     },
     4.4 => { # CSd5
         Name => 'ScreenTips',
         Mask => 0x04,
-        PrintConv => { 0x00 => 'Off', 0x04 => 'On' },
+        PrintConv => \%offOn,
     },
     4.5 => { # CSd1-a
@@ -3228,8 +8117,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'Off',
-            0x01 => '1',
-            0x02 => '2',
-            0x03 => '3',
+            0 => 'Off',
+            1 => '1',
+            2 => '2',
+            3 => '3',
         },
     },
@@ -3238,6 +8127,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => '+ 0 -',
-            0x80 => '- 0 +',
+            0 => '+ 0 -',
+            1 => '- 0 +',
         },
     },
@@ -3246,7 +8135,7 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'Off',
-            0x01 => 'On',
-            0x02 => 'On Auto Reset',
+            0 => 'Off',
+            1 => 'On',
+            2 => 'On Auto Reset',
         },
     },
@@ -3255,6 +8144,6 @@
         Mask => 0x40,
         PrintConv => {
-            0x00 => '1/3 EV',
-            0x40 => '1/2 EV',
+            0 => '1/3 EV',
+            1 => '1/2 EV',
         },
     },
@@ -3263,6 +8152,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => '1/3 EV',
-            0x10 => '1/2 EV',
+            0 => '1/3 EV',
+            1 => '1/2 EV',
         },
     },
@@ -3271,9 +8160,9 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '6 mm',
-            0x20 => '8 mm',
-            0x40 => '10 mm',
-            0x60 => '13 mm',
-            0x80 => 'Average',
+            0 => '6 mm',
+            1 => '8 mm',
+            2 => '10 mm',
+            3 => '13 mm',
+            4 => 'Average',
         },
     },
@@ -3281,8 +8170,5 @@
         Name => 'ExposureDelayMode',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     10.2 => { # CSd6
@@ -3300,9 +8186,9 @@
         Mask => 0xe0, #(NC)
         PrintConv => {
-            0x00 => 'AE & Flash', # default
-            0x20 => 'AE Only',
-            0x40 => 'Flash Only', #(NC)
-            0x60 => 'WB Bracketing', #(NC)
-            0x80 => 'Active D-Lighting', #(NC)
+            0 => 'AE & Flash', # default
+            1 => 'AE Only',
+            2 => 'Flash Only', #(NC)
+            3 => 'WB Bracketing', #(NC)
+            4 => 'Active D-Lighting', #(NC)
         },
     },
@@ -3311,6 +8197,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => '0,-,+',
-            0x10 => '-,0,+',
+            0 => '0,-,+',
+            1 => '-,0,+',
         },
     },
@@ -3319,24 +8205,24 @@
         Mask => 0xf8,
         PrintConv => {
-            0x00 => 'Grid Display',
-            0x08 => 'FV Lock',
-            0x10 => 'Flash Off',
-            0x18 => 'Matrix Metering',
-            0x20 => 'Center-weighted Metering',
-            0x28 => 'Spot Metering',
-            0x30 => 'My Menu Top',
-            0x38 => '+ NEF (RAW)',
-            0x40 => 'Active D-Lighting',
-            0x48 => 'Preview',
-            0x50 => 'AE/AF Lock',
-            0x58 => 'AE Lock Only',
-            0x60 => 'AF Lock Only',
-            0x68 => 'AE Lock (hold)',
-            0x70 => 'Bracketing Burst',
-            0x78 => 'Playback',
-            0x80 => '1EV Step Speed/Aperture',
-            0x88 => 'Choose Non-CPU Lens',
-            0x90 => 'Virtual Horizon',
-            0x98 => 'Start Movie Recording',
+            0 => 'Grid Display',
+            1 => 'FV Lock',
+            2 => 'Flash Off',
+            3 => 'Matrix Metering',
+            4 => 'Center-weighted Metering',
+            5 => 'Spot Metering',
+            6 => 'My Menu Top',
+            7 => '+ NEF (RAW)',
+            8 => 'Active D-Lighting',
+            9 => 'Preview',
+            10 => 'AE/AF Lock',
+            11 => 'AE Lock Only',
+            12 => 'AF Lock Only',
+            13 => 'AE Lock (hold)',
+            14 => 'Bracketing Burst',
+            15 => 'Playback',
+            16 => '1EV Step Speed/Aperture',
+            17 => 'Choose Non-CPU Lens',
+            18 => 'Virtual Horizon',
+            19 => 'Start Movie Recording',
         },
     },
@@ -3345,24 +8231,24 @@
         Mask => 0xf8,
         PrintConv => {
-            0x00 => 'Grid Display',
-            0x08 => 'FV Lock',
-            0x10 => 'Flash Off',
-            0x18 => 'Matrix Metering',
-            0x20 => 'Center-weighted Metering',
-            0x28 => 'Spot Metering',
-            0x30 => 'My Menu Top',
-            0x38 => '+ NEF (RAW)',
-            0x40 => 'Active D-Lighting',
-            0x48 => 'Preview',
-            0x50 => 'AE/AF Lock',
-            0x58 => 'AE Lock Only',
-            0x60 => 'AF Lock Only',
-            0x68 => 'AE Lock (hold)',
-            0x70 => 'Bracketing Burst',
-            0x78 => 'Playback',
-            0x80 => '1EV Step Speed/Aperture',
-            0x88 => 'Choose Non-CPU Lens',
-            0x90 => 'Virtual Horizon',
-            0x98 => 'Start Movie Recording',
+            0 => 'Grid Display',
+            1 => 'FV Lock',
+            2 => 'Flash Off',
+            3 => 'Matrix Metering',
+            4 => 'Center-weighted Metering',
+            5 => 'Spot Metering',
+            6 => 'My Menu Top',
+            7 => '+ NEF (RAW)',
+            8 => 'Active D-Lighting',
+            9 => 'Preview',
+            10 => 'AE/AF Lock',
+            11 => 'AE Lock Only',
+            12 => 'AF Lock Only',
+            13 => 'AE Lock (hold)',
+            14 => 'Bracketing Burst',
+            15 => 'Playback',
+            16 => '1EV Step Speed/Aperture',
+            17 => 'Choose Non-CPU Lens',
+            18 => 'Virtual Horizon',
+            19 => 'Start Movie Recording',
         },
     },
@@ -3371,10 +8257,10 @@
         Mask => 0x38,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x08 => 'AE Lock Only',
-            0x10 => 'AF Lock Only',
-            0x18 => 'AE Lock (hold)',
-            0x20 => 'AF-ON',
-            0x28 => 'FV Lock',
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only',
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
+            5 => 'FV Lock',
         },
     },
@@ -3383,8 +8269,8 @@
         Mask => 0x18,
         PrintConv => {
-            0x08 => 'Select Center Focus Point',
-            0x10 => 'Highlight Active Focus Point',
-            0x18 => 'Not Used', #(NC)
-            0x00 => 'Off', #(NC)
+            1 => 'Select Center Focus Point',
+            2 => 'Highlight Active Focus Point',
+            3 => 'Not Used', #(NC)
+            0 => 'Off', #(NC)
         },
     },
@@ -3392,5 +8278,5 @@
         Name => 'CommandDialsReverseRotation',
         Mask => 0x80,
-        PrintConv => { 0x00 => 'No', 0x80 => 'Yes' },
+        PrintConv => \%noYes,
     },
     17.2 => { # CSf6-b
@@ -3398,7 +8284,7 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Off',
-            0x20 => 'On',
-            0x40 => 'On (A mode only)',
+            0 => 'Off',
+            1 => 'On',
+            2 => 'On (A mode only)',
         },
     },
@@ -3407,6 +8293,6 @@
         Mask => 0x04,
         PrintConv => {
-            0x00 => 'Sub-command Dial',
-            0x04 => 'Aperture Ring',
+            0 => 'Sub-command Dial',
+            1 => 'Aperture Ring',
         },
     },
@@ -3415,7 +8301,7 @@
         Mask => 0x18,
         PrintConv => {
-            0x00 => 'On',
-            0x10 => 'On (Image Review Exclude)',
-            0x08 => 'Off',
+            0 => 'On',
+            2 => 'On (Image Review Exclude)',
+            1 => 'Off',
         },
     },
